/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
package org.eclipse.lsat.dispatching.teditor.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class DispatchingGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class ActivityDispatchingElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.ActivityDispatching");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cActivityDispatchingAction_0 = (Action)cGroup.eContents().get(0);
		private final Assignment cImportsAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cImportsImportParserRuleCall_1_0 = (RuleCall)cImportsAssignment_1.eContents().get(0);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cThroughputKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2_1 = (Keyword)cGroup_2.eContents().get(1);
		private final Group cGroup_2_2 = (Group)cGroup_2.eContents().get(2);
		private final Keyword cIterationsKeyword_2_2_0 = (Keyword)cGroup_2_2.eContents().get(0);
		private final Keyword cColonKeyword_2_2_1 = (Keyword)cGroup_2_2.eContents().get(1);
		private final Assignment cNumberOfIterationsAssignment_2_2_2 = (Assignment)cGroup_2_2.eContents().get(2);
		private final RuleCall cNumberOfIterationsINTTerminalRuleCall_2_2_2_0 = (RuleCall)cNumberOfIterationsAssignment_2_2_2.eContents().get(0);
		private final Assignment cResourceIterationsAssignment_2_3 = (Assignment)cGroup_2.eContents().get(3);
		private final RuleCall cResourceIterationsResourceIterationsMapEntryParserRuleCall_2_3_0 = (RuleCall)cResourceIterationsAssignment_2_3.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_2_4 = (Keyword)cGroup_2.eContents().get(4);
		private final Assignment cDispatchGroupsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cDispatchGroupsDispatchGroupParserRuleCall_3_0 = (RuleCall)cDispatchGroupsAssignment_3.eContents().get(0);
		
		//ActivityDispatching:
		//	{ActivityDispatching} imports+=Import* ('throughput'
		//	'{' ('iterations' ':' numberOfIterations=INT)?
		//	resourceIterations+=ResourceIterationsMapEntry*
		//	'}')?
		//	dispatchGroups+=DispatchGroup*;
		@Override public ParserRule getRule() { return rule; }
		
		//{ActivityDispatching} imports+=Import* ('throughput' '{' ('iterations' ':' numberOfIterations=INT)?
		//resourceIterations+=ResourceIterationsMapEntry* '}')? dispatchGroups+=DispatchGroup*
		public Group getGroup() { return cGroup; }
		
		//{ActivityDispatching}
		public Action getActivityDispatchingAction_0() { return cActivityDispatchingAction_0; }
		
		//imports+=Import*
		public Assignment getImportsAssignment_1() { return cImportsAssignment_1; }
		
		//Import
		public RuleCall getImportsImportParserRuleCall_1_0() { return cImportsImportParserRuleCall_1_0; }
		
		//('throughput' '{' ('iterations' ':' numberOfIterations=INT)? resourceIterations+=ResourceIterationsMapEntry* '}')?
		public Group getGroup_2() { return cGroup_2; }
		
		//'throughput'
		public Keyword getThroughputKeyword_2_0() { return cThroughputKeyword_2_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2_1() { return cLeftCurlyBracketKeyword_2_1; }
		
		//('iterations' ':' numberOfIterations=INT)?
		public Group getGroup_2_2() { return cGroup_2_2; }
		
		//'iterations'
		public Keyword getIterationsKeyword_2_2_0() { return cIterationsKeyword_2_2_0; }
		
		//':'
		public Keyword getColonKeyword_2_2_1() { return cColonKeyword_2_2_1; }
		
		//numberOfIterations=INT
		public Assignment getNumberOfIterationsAssignment_2_2_2() { return cNumberOfIterationsAssignment_2_2_2; }
		
		//INT
		public RuleCall getNumberOfIterationsINTTerminalRuleCall_2_2_2_0() { return cNumberOfIterationsINTTerminalRuleCall_2_2_2_0; }
		
		//resourceIterations+=ResourceIterationsMapEntry*
		public Assignment getResourceIterationsAssignment_2_3() { return cResourceIterationsAssignment_2_3; }
		
		//ResourceIterationsMapEntry
		public RuleCall getResourceIterationsResourceIterationsMapEntryParserRuleCall_2_3_0() { return cResourceIterationsResourceIterationsMapEntryParserRuleCall_2_3_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_2_4() { return cRightCurlyBracketKeyword_2_4; }
		
		//dispatchGroups+=DispatchGroup*
		public Assignment getDispatchGroupsAssignment_3() { return cDispatchGroupsAssignment_3; }
		
		//DispatchGroup
		public RuleCall getDispatchGroupsDispatchGroupParserRuleCall_3_0() { return cDispatchGroupsDispatchGroupParserRuleCall_3_0; }
	}
	public class ResourceIterationsMapEntryElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.ResourceIterationsMapEntry");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cIterationsKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cFullStopKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cKeyAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final CrossReference cKeyIResourceCrossReference_2_0 = (CrossReference)cKeyAssignment_2.eContents().get(0);
		private final RuleCall cKeyIResourceResourceQualifiedNameParserRuleCall_2_0_1 = (RuleCall)cKeyIResourceCrossReference_2_0.eContents().get(1);
		private final Keyword cColonKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cValueAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cValueINTTerminalRuleCall_4_0 = (RuleCall)cValueAssignment_4.eContents().get(0);
		
		//ResourceIterationsMapEntry:
		//	'iterations' '.' key=[machine::IResource|ResourceQualifiedName] ':' value=INT;
		@Override public ParserRule getRule() { return rule; }
		
		//'iterations' '.' key=[machine::IResource|ResourceQualifiedName] ':' value=INT
		public Group getGroup() { return cGroup; }
		
		//'iterations'
		public Keyword getIterationsKeyword_0() { return cIterationsKeyword_0; }
		
		//'.'
		public Keyword getFullStopKeyword_1() { return cFullStopKeyword_1; }
		
		//key=[machine::IResource|ResourceQualifiedName]
		public Assignment getKeyAssignment_2() { return cKeyAssignment_2; }
		
		//[machine::IResource|ResourceQualifiedName]
		public CrossReference getKeyIResourceCrossReference_2_0() { return cKeyIResourceCrossReference_2_0; }
		
		//ResourceQualifiedName
		public RuleCall getKeyIResourceResourceQualifiedNameParserRuleCall_2_0_1() { return cKeyIResourceResourceQualifiedNameParserRuleCall_2_0_1; }
		
		//':'
		public Keyword getColonKeyword_3() { return cColonKeyword_3; }
		
		//value=INT
		public Assignment getValueAssignment_4() { return cValueAssignment_4; }
		
		//INT
		public RuleCall getValueINTTerminalRuleCall_4_0() { return cValueINTTerminalRuleCall_4_0; }
	}
	public class DispatchGroupElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.DispatchGroup");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cDispatchGroupAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cActivitiesKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameIDStringParserRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cLeftParenthesisKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Group cGroup_3_1 = (Group)cGroup_3.eContents().get(1);
		private final Assignment cUserAttributesAssignment_3_1_0 = (Assignment)cGroup_3_1.eContents().get(0);
		private final RuleCall cUserAttributesAttributesMapEntryParserRuleCall_3_1_0_0 = (RuleCall)cUserAttributesAssignment_3_1_0.eContents().get(0);
		private final Group cGroup_3_1_1 = (Group)cGroup_3_1.eContents().get(1);
		private final Keyword cCommaKeyword_3_1_1_0 = (Keyword)cGroup_3_1_1.eContents().get(0);
		private final Assignment cUserAttributesAssignment_3_1_1_1 = (Assignment)cGroup_3_1_1.eContents().get(1);
		private final RuleCall cUserAttributesAttributesMapEntryParserRuleCall_3_1_1_1_0 = (RuleCall)cUserAttributesAssignment_3_1_1_1.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_3_2 = (Keyword)cGroup_3.eContents().get(2);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cRepeatKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cIteratorNameAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cIteratorNameIDStringParserRuleCall_4_1_0 = (RuleCall)cIteratorNameAssignment_4_1.eContents().get(0);
		private final Keyword cColonKeyword_4_2 = (Keyword)cGroup_4.eContents().get(2);
		private final Alternatives cAlternatives_4_3 = (Alternatives)cGroup_4.eContents().get(3);
		private final Assignment cRepeatsAssignment_4_3_0 = (Assignment)cAlternatives_4_3.eContents().get(0);
		private final RuleCall cRepeatsNumberRepeatsParserRuleCall_4_3_0_0 = (RuleCall)cRepeatsAssignment_4_3_0.eContents().get(0);
		private final Group cGroup_4_3_1 = (Group)cAlternatives_4_3.eContents().get(1);
		private final Keyword cLeftSquareBracketKeyword_4_3_1_0 = (Keyword)cGroup_4_3_1.eContents().get(0);
		private final Assignment cRepeatsAssignment_4_3_1_1 = (Assignment)cGroup_4_3_1.eContents().get(1);
		private final RuleCall cRepeatsRangeParserRuleCall_4_3_1_1_0 = (RuleCall)cRepeatsAssignment_4_3_1_1.eContents().get(0);
		private final Group cGroup_4_3_1_2 = (Group)cGroup_4_3_1.eContents().get(2);
		private final Keyword cCommaKeyword_4_3_1_2_0 = (Keyword)cGroup_4_3_1_2.eContents().get(0);
		private final Assignment cRepeatsAssignment_4_3_1_2_1 = (Assignment)cGroup_4_3_1_2.eContents().get(1);
		private final RuleCall cRepeatsRangeParserRuleCall_4_3_1_2_1_0 = (RuleCall)cRepeatsAssignment_4_3_1_2_1.eContents().get(0);
		private final Keyword cRightSquareBracketKeyword_4_3_1_3 = (Keyword)cGroup_4_3_1.eContents().get(3);
		private final Keyword cLeftCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cYieldKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Keyword cColonKeyword_6_1 = (Keyword)cGroup_6.eContents().get(1);
		private final Assignment cYieldAssignment_6_2 = (Assignment)cGroup_6.eContents().get(2);
		private final RuleCall cYieldINTTerminalRuleCall_6_2_0 = (RuleCall)cYieldAssignment_6_2.eContents().get(0);
		private final Assignment cResourceYieldAssignment_7 = (Assignment)cGroup.eContents().get(7);
		private final RuleCall cResourceYieldResourceYieldMapEntryParserRuleCall_7_0 = (RuleCall)cResourceYieldAssignment_7.eContents().get(0);
		private final Group cGroup_8 = (Group)cGroup.eContents().get(8);
		private final Keyword cOffsetKeyword_8_0 = (Keyword)cGroup_8.eContents().get(0);
		private final Keyword cColonKeyword_8_1 = (Keyword)cGroup_8.eContents().get(1);
		private final Assignment cOffsetAssignment_8_2 = (Assignment)cGroup_8.eContents().get(2);
		private final RuleCall cOffsetEBigDecimalParserRuleCall_8_2_0 = (RuleCall)cOffsetAssignment_8_2.eContents().get(0);
		private final Assignment cDispatchesAssignment_9 = (Assignment)cGroup.eContents().get(9);
		private final RuleCall cDispatchesDispatchParserRuleCall_9_0 = (RuleCall)cDispatchesAssignment_9.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_10 = (Keyword)cGroup.eContents().get(10);
		
		//DispatchGroup:
		//	{DispatchGroup}
		//	'activities'
		//	name=IDString? ('(' (userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')? ('repeat'
		//	iteratorName=IDString? ':' (=> repeats+=NumberRepeats | '[' repeats+=Range (',' repeats+=Range)* ']'))?
		//	'{' ('yield' ':' yield=INT)?
		//	resourceYield+=ResourceYieldMapEntry* ('offset' ':' offset=EBigDecimal)?
		//	dispatches+=Dispatch*
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{DispatchGroup} 'activities' name=IDString? ('(' (userAttributes+=AttributesMapEntry (','
		//userAttributes+=AttributesMapEntry)*)? ')')? ('repeat' iteratorName=IDString? ':' (=> repeats+=NumberRepeats | '['
		//repeats+=Range (',' repeats+=Range)* ']'))? '{' ('yield' ':' yield=INT)? resourceYield+=ResourceYieldMapEntry*
		//('offset' ':' offset=EBigDecimal)? dispatches+=Dispatch* '}'
		public Group getGroup() { return cGroup; }
		
		//{DispatchGroup}
		public Action getDispatchGroupAction_0() { return cDispatchGroupAction_0; }
		
		//'activities'
		public Keyword getActivitiesKeyword_1() { return cActivitiesKeyword_1; }
		
		//name=IDString?
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//IDString
		public RuleCall getNameIDStringParserRuleCall_2_0() { return cNameIDStringParserRuleCall_2_0; }
		
		//('(' (userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')?
		public Group getGroup_3() { return cGroup_3; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_3_0() { return cLeftParenthesisKeyword_3_0; }
		
		//(userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)?
		public Group getGroup_3_1() { return cGroup_3_1; }
		
		//userAttributes+=AttributesMapEntry
		public Assignment getUserAttributesAssignment_3_1_0() { return cUserAttributesAssignment_3_1_0; }
		
		//AttributesMapEntry
		public RuleCall getUserAttributesAttributesMapEntryParserRuleCall_3_1_0_0() { return cUserAttributesAttributesMapEntryParserRuleCall_3_1_0_0; }
		
		//(',' userAttributes+=AttributesMapEntry)*
		public Group getGroup_3_1_1() { return cGroup_3_1_1; }
		
		//','
		public Keyword getCommaKeyword_3_1_1_0() { return cCommaKeyword_3_1_1_0; }
		
		//userAttributes+=AttributesMapEntry
		public Assignment getUserAttributesAssignment_3_1_1_1() { return cUserAttributesAssignment_3_1_1_1; }
		
		//AttributesMapEntry
		public RuleCall getUserAttributesAttributesMapEntryParserRuleCall_3_1_1_1_0() { return cUserAttributesAttributesMapEntryParserRuleCall_3_1_1_1_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_3_2() { return cRightParenthesisKeyword_3_2; }
		
		//('repeat' iteratorName=IDString? ':' (=> repeats+=NumberRepeats | '[' repeats+=Range (',' repeats+=Range)* ']'))?
		public Group getGroup_4() { return cGroup_4; }
		
		//'repeat'
		public Keyword getRepeatKeyword_4_0() { return cRepeatKeyword_4_0; }
		
		//iteratorName=IDString?
		public Assignment getIteratorNameAssignment_4_1() { return cIteratorNameAssignment_4_1; }
		
		//IDString
		public RuleCall getIteratorNameIDStringParserRuleCall_4_1_0() { return cIteratorNameIDStringParserRuleCall_4_1_0; }
		
		//':'
		public Keyword getColonKeyword_4_2() { return cColonKeyword_4_2; }
		
		//(=> repeats+=NumberRepeats | '[' repeats+=Range (',' repeats+=Range)* ']')
		public Alternatives getAlternatives_4_3() { return cAlternatives_4_3; }
		
		//=> repeats+=NumberRepeats
		public Assignment getRepeatsAssignment_4_3_0() { return cRepeatsAssignment_4_3_0; }
		
		//NumberRepeats
		public RuleCall getRepeatsNumberRepeatsParserRuleCall_4_3_0_0() { return cRepeatsNumberRepeatsParserRuleCall_4_3_0_0; }
		
		//'[' repeats+=Range (',' repeats+=Range)* ']'
		public Group getGroup_4_3_1() { return cGroup_4_3_1; }
		
		//'['
		public Keyword getLeftSquareBracketKeyword_4_3_1_0() { return cLeftSquareBracketKeyword_4_3_1_0; }
		
		//repeats+=Range
		public Assignment getRepeatsAssignment_4_3_1_1() { return cRepeatsAssignment_4_3_1_1; }
		
		//Range
		public RuleCall getRepeatsRangeParserRuleCall_4_3_1_1_0() { return cRepeatsRangeParserRuleCall_4_3_1_1_0; }
		
		//(',' repeats+=Range)*
		public Group getGroup_4_3_1_2() { return cGroup_4_3_1_2; }
		
		//','
		public Keyword getCommaKeyword_4_3_1_2_0() { return cCommaKeyword_4_3_1_2_0; }
		
		//repeats+=Range
		public Assignment getRepeatsAssignment_4_3_1_2_1() { return cRepeatsAssignment_4_3_1_2_1; }
		
		//Range
		public RuleCall getRepeatsRangeParserRuleCall_4_3_1_2_1_0() { return cRepeatsRangeParserRuleCall_4_3_1_2_1_0; }
		
		//']'
		public Keyword getRightSquareBracketKeyword_4_3_1_3() { return cRightSquareBracketKeyword_4_3_1_3; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_5() { return cLeftCurlyBracketKeyword_5; }
		
		//('yield' ':' yield=INT)?
		public Group getGroup_6() { return cGroup_6; }
		
		//'yield'
		public Keyword getYieldKeyword_6_0() { return cYieldKeyword_6_0; }
		
		//':'
		public Keyword getColonKeyword_6_1() { return cColonKeyword_6_1; }
		
		//yield=INT
		public Assignment getYieldAssignment_6_2() { return cYieldAssignment_6_2; }
		
		//INT
		public RuleCall getYieldINTTerminalRuleCall_6_2_0() { return cYieldINTTerminalRuleCall_6_2_0; }
		
		//resourceYield+=ResourceYieldMapEntry*
		public Assignment getResourceYieldAssignment_7() { return cResourceYieldAssignment_7; }
		
		//ResourceYieldMapEntry
		public RuleCall getResourceYieldResourceYieldMapEntryParserRuleCall_7_0() { return cResourceYieldResourceYieldMapEntryParserRuleCall_7_0; }
		
		//('offset' ':' offset=EBigDecimal)?
		public Group getGroup_8() { return cGroup_8; }
		
		//'offset'
		public Keyword getOffsetKeyword_8_0() { return cOffsetKeyword_8_0; }
		
		//':'
		public Keyword getColonKeyword_8_1() { return cColonKeyword_8_1; }
		
		//offset=EBigDecimal
		public Assignment getOffsetAssignment_8_2() { return cOffsetAssignment_8_2; }
		
		//EBigDecimal
		public RuleCall getOffsetEBigDecimalParserRuleCall_8_2_0() { return cOffsetEBigDecimalParserRuleCall_8_2_0; }
		
		//dispatches+=Dispatch*
		public Assignment getDispatchesAssignment_9() { return cDispatchesAssignment_9; }
		
		//Dispatch
		public RuleCall getDispatchesDispatchParserRuleCall_9_0() { return cDispatchesDispatchParserRuleCall_9_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_10() { return cRightCurlyBracketKeyword_10; }
	}
	public class NumberRepeatsElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.NumberRepeats");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cRepeatAction_0 = (Action)cGroup.eContents().get(0);
		private final Assignment cNumRepeatsAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNumRepeatsINTTerminalRuleCall_1_0 = (RuleCall)cNumRepeatsAssignment_1.eContents().get(0);
		
		//NumberRepeats Repeat:
		//	{Repeat} numRepeats=INT;
		@Override public ParserRule getRule() { return rule; }
		
		//{Repeat} numRepeats=INT
		public Group getGroup() { return cGroup; }
		
		//{Repeat}
		public Action getRepeatAction_0() { return cRepeatAction_0; }
		
		//numRepeats=INT
		public Assignment getNumRepeatsAssignment_1() { return cNumRepeatsAssignment_1; }
		
		//INT
		public RuleCall getNumRepeatsINTTerminalRuleCall_1_0() { return cNumRepeatsINTTerminalRuleCall_1_0; }
	}
	public class RangeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.Range");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cRepeatAction_0 = (Action)cGroup.eContents().get(0);
		private final Alternatives cAlternatives_1 = (Alternatives)cGroup.eContents().get(1);
		private final Assignment cStartAssignment_1_0 = (Assignment)cAlternatives_1.eContents().get(0);
		private final RuleCall cStartINTTerminalRuleCall_1_0_0 = (RuleCall)cStartAssignment_1_0.eContents().get(0);
		private final Group cGroup_1_1 = (Group)cAlternatives_1.eContents().get(1);
		private final Assignment cStartAssignment_1_1_0 = (Assignment)cGroup_1_1.eContents().get(0);
		private final RuleCall cStartINTTerminalRuleCall_1_1_0_0 = (RuleCall)cStartAssignment_1_1_0.eContents().get(0);
		private final Keyword cFullStopFullStopKeyword_1_1_1 = (Keyword)cGroup_1_1.eContents().get(1);
		private final Assignment cEndAssignment_1_1_2 = (Assignment)cGroup_1_1.eContents().get(2);
		private final RuleCall cEndINTTerminalRuleCall_1_1_2_0 = (RuleCall)cEndAssignment_1_1_2.eContents().get(0);
		
		//Range Repeat:
		//	{Repeat} (start=INT | start=INT ".." end=INT);
		@Override public ParserRule getRule() { return rule; }
		
		//{Repeat} (start=INT | start=INT ".." end=INT)
		public Group getGroup() { return cGroup; }
		
		//{Repeat}
		public Action getRepeatAction_0() { return cRepeatAction_0; }
		
		//(start=INT | start=INT ".." end=INT)
		public Alternatives getAlternatives_1() { return cAlternatives_1; }
		
		//start=INT
		public Assignment getStartAssignment_1_0() { return cStartAssignment_1_0; }
		
		//INT
		public RuleCall getStartINTTerminalRuleCall_1_0_0() { return cStartINTTerminalRuleCall_1_0_0; }
		
		//start=INT ".." end=INT
		public Group getGroup_1_1() { return cGroup_1_1; }
		
		//start=INT
		public Assignment getStartAssignment_1_1_0() { return cStartAssignment_1_1_0; }
		
		//INT
		public RuleCall getStartINTTerminalRuleCall_1_1_0_0() { return cStartINTTerminalRuleCall_1_1_0_0; }
		
		//".."
		public Keyword getFullStopFullStopKeyword_1_1_1() { return cFullStopFullStopKeyword_1_1_1; }
		
		//end=INT
		public Assignment getEndAssignment_1_1_2() { return cEndAssignment_1_1_2; }
		
		//INT
		public RuleCall getEndINTTerminalRuleCall_1_1_2_0() { return cEndINTTerminalRuleCall_1_1_2_0; }
	}
	public class ResourceYieldMapEntryElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.ResourceYieldMapEntry");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cYieldKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cKeyAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final CrossReference cKeyIResourceCrossReference_1_0 = (CrossReference)cKeyAssignment_1.eContents().get(0);
		private final RuleCall cKeyIResourceResourceQualifiedNameParserRuleCall_1_0_1 = (RuleCall)cKeyIResourceCrossReference_1_0.eContents().get(1);
		private final Keyword cColonKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cValueAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cValueINTTerminalRuleCall_3_0 = (RuleCall)cValueAssignment_3.eContents().get(0);
		
		//ResourceYieldMapEntry:
		//	'yield' key=[machine::IResource|ResourceQualifiedName] ':' value=INT;
		@Override public ParserRule getRule() { return rule; }
		
		//'yield' key=[machine::IResource|ResourceQualifiedName] ':' value=INT
		public Group getGroup() { return cGroup; }
		
		//'yield'
		public Keyword getYieldKeyword_0() { return cYieldKeyword_0; }
		
		//key=[machine::IResource|ResourceQualifiedName]
		public Assignment getKeyAssignment_1() { return cKeyAssignment_1; }
		
		//[machine::IResource|ResourceQualifiedName]
		public CrossReference getKeyIResourceCrossReference_1_0() { return cKeyIResourceCrossReference_1_0; }
		
		//ResourceQualifiedName
		public RuleCall getKeyIResourceResourceQualifiedNameParserRuleCall_1_0_1() { return cKeyIResourceResourceQualifiedNameParserRuleCall_1_0_1; }
		
		//':'
		public Keyword getColonKeyword_2() { return cColonKeyword_2; }
		
		//value=INT
		public Assignment getValueAssignment_3() { return cValueAssignment_3; }
		
		//INT
		public RuleCall getValueINTTerminalRuleCall_3_0() { return cValueINTTerminalRuleCall_3_0; }
	}
	public class AttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.Attribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cAttributeAction_0 = (Action)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		
		//Attribute:
		//	{Attribute} name=ID;
		@Override public ParserRule getRule() { return rule; }
		
		//{Attribute} name=ID
		public Group getGroup() { return cGroup; }
		
		//{Attribute}
		public Action getAttributeAction_0() { return cAttributeAction_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
	}
	public class DispatchElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.Dispatch");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cActivityAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final CrossReference cActivityActivityCrossReference_0_0 = (CrossReference)cActivityAssignment_0.eContents().get(0);
		private final RuleCall cActivityActivityIDTerminalRuleCall_0_0_1 = (RuleCall)cActivityActivityCrossReference_0_0.eContents().get(1);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cLeftSquareBracketKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Assignment cResourceItemsAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final CrossReference cResourceItemsResourceItemCrossReference_1_1_0 = (CrossReference)cResourceItemsAssignment_1_1.eContents().get(0);
		private final RuleCall cResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_1_0_1 = (RuleCall)cResourceItemsResourceItemCrossReference_1_1_0.eContents().get(1);
		private final Group cGroup_1_2 = (Group)cGroup_1.eContents().get(2);
		private final Keyword cCommaKeyword_1_2_0 = (Keyword)cGroup_1_2.eContents().get(0);
		private final Assignment cResourceItemsAssignment_1_2_1 = (Assignment)cGroup_1_2.eContents().get(1);
		private final CrossReference cResourceItemsResourceItemCrossReference_1_2_1_0 = (CrossReference)cResourceItemsAssignment_1_2_1.eContents().get(0);
		private final RuleCall cResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_2_1_0_1 = (RuleCall)cResourceItemsResourceItemCrossReference_1_2_1_0.eContents().get(1);
		private final Keyword cRightSquareBracketKeyword_1_3 = (Keyword)cGroup_1.eContents().get(3);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cLeftParenthesisKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final Assignment cDescriptionAssignment_2_1 = (Assignment)cGroup_2.eContents().get(1);
		private final RuleCall cDescriptionSTRINGTerminalRuleCall_2_1_0 = (RuleCall)cDescriptionAssignment_2_1.eContents().get(0);
		private final Group cGroup_2_2 = (Group)cGroup_2.eContents().get(2);
		private final Assignment cUserAttributesAssignment_2_2_0 = (Assignment)cGroup_2_2.eContents().get(0);
		private final RuleCall cUserAttributesAttributesMapEntryParserRuleCall_2_2_0_0 = (RuleCall)cUserAttributesAssignment_2_2_0.eContents().get(0);
		private final Group cGroup_2_2_1 = (Group)cGroup_2_2.eContents().get(1);
		private final Keyword cCommaKeyword_2_2_1_0 = (Keyword)cGroup_2_2_1.eContents().get(0);
		private final Assignment cUserAttributesAssignment_2_2_1_1 = (Assignment)cGroup_2_2_1.eContents().get(1);
		private final RuleCall cUserAttributesAttributesMapEntryParserRuleCall_2_2_1_1_0 = (RuleCall)cUserAttributesAssignment_2_2_1_1.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_2_3 = (Keyword)cGroup_2.eContents().get(3);
		
		//Dispatch:
		//	activity=[activity::Activity] ('[' resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName] (','
		//	resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName])* ']')? ('(' description=STRING?
		//	(userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')?;
		@Override public ParserRule getRule() { return rule; }
		
		//activity=[activity::Activity] ('[' resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName] (','
		//resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName])* ']')? ('(' description=STRING?
		//(userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')?
		public Group getGroup() { return cGroup; }
		
		//activity=[activity::Activity]
		public Assignment getActivityAssignment_0() { return cActivityAssignment_0; }
		
		//[activity::Activity]
		public CrossReference getActivityActivityCrossReference_0_0() { return cActivityActivityCrossReference_0_0; }
		
		//ID
		public RuleCall getActivityActivityIDTerminalRuleCall_0_0_1() { return cActivityActivityIDTerminalRuleCall_0_0_1; }
		
		//('[' resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName] (','
		//resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName])* ']')?
		public Group getGroup_1() { return cGroup_1; }
		
		//'['
		public Keyword getLeftSquareBracketKeyword_1_0() { return cLeftSquareBracketKeyword_1_0; }
		
		//resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName]
		public Assignment getResourceItemsAssignment_1_1() { return cResourceItemsAssignment_1_1; }
		
		//[machine::ResourceItem|ResourceItemQualifiedName]
		public CrossReference getResourceItemsResourceItemCrossReference_1_1_0() { return cResourceItemsResourceItemCrossReference_1_1_0; }
		
		//ResourceItemQualifiedName
		public RuleCall getResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_1_0_1() { return cResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_1_0_1; }
		
		//(',' resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName])*
		public Group getGroup_1_2() { return cGroup_1_2; }
		
		//','
		public Keyword getCommaKeyword_1_2_0() { return cCommaKeyword_1_2_0; }
		
		//resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName]
		public Assignment getResourceItemsAssignment_1_2_1() { return cResourceItemsAssignment_1_2_1; }
		
		//[machine::ResourceItem|ResourceItemQualifiedName]
		public CrossReference getResourceItemsResourceItemCrossReference_1_2_1_0() { return cResourceItemsResourceItemCrossReference_1_2_1_0; }
		
		//ResourceItemQualifiedName
		public RuleCall getResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_2_1_0_1() { return cResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_2_1_0_1; }
		
		//']'
		public Keyword getRightSquareBracketKeyword_1_3() { return cRightSquareBracketKeyword_1_3; }
		
		//('(' description=STRING? (userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')?
		public Group getGroup_2() { return cGroup_2; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_2_0() { return cLeftParenthesisKeyword_2_0; }
		
		//description=STRING?
		public Assignment getDescriptionAssignment_2_1() { return cDescriptionAssignment_2_1; }
		
		//STRING
		public RuleCall getDescriptionSTRINGTerminalRuleCall_2_1_0() { return cDescriptionSTRINGTerminalRuleCall_2_1_0; }
		
		//(userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)?
		public Group getGroup_2_2() { return cGroup_2_2; }
		
		//userAttributes+=AttributesMapEntry
		public Assignment getUserAttributesAssignment_2_2_0() { return cUserAttributesAssignment_2_2_0; }
		
		//AttributesMapEntry
		public RuleCall getUserAttributesAttributesMapEntryParserRuleCall_2_2_0_0() { return cUserAttributesAttributesMapEntryParserRuleCall_2_2_0_0; }
		
		//(',' userAttributes+=AttributesMapEntry)*
		public Group getGroup_2_2_1() { return cGroup_2_2_1; }
		
		//','
		public Keyword getCommaKeyword_2_2_1_0() { return cCommaKeyword_2_2_1_0; }
		
		//userAttributes+=AttributesMapEntry
		public Assignment getUserAttributesAssignment_2_2_1_1() { return cUserAttributesAssignment_2_2_1_1; }
		
		//AttributesMapEntry
		public RuleCall getUserAttributesAttributesMapEntryParserRuleCall_2_2_1_1_0() { return cUserAttributesAttributesMapEntryParserRuleCall_2_2_1_1_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_2_3() { return cRightParenthesisKeyword_2_3; }
	}
	public class AttributesMapEntryElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.AttributesMapEntry");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cAttributesMapEntryAction_0 = (Action)cGroup.eContents().get(0);
		private final Assignment cKeyAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cKeyAttributeParserRuleCall_1_0 = (RuleCall)cKeyAssignment_1.eContents().get(0);
		private final Alternatives cAlternatives_2 = (Alternatives)cGroup.eContents().get(2);
		private final Keyword cColonKeyword_2_0 = (Keyword)cAlternatives_2.eContents().get(0);
		private final Keyword cEqualsSignKeyword_2_1 = (Keyword)cAlternatives_2.eContents().get(1);
		private final Assignment cValueAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final Alternatives cValueAlternatives_3_0 = (Alternatives)cValueAssignment_3.eContents().get(0);
		private final RuleCall cValueIDStringParserRuleCall_3_0_0 = (RuleCall)cValueAlternatives_3_0.eContents().get(0);
		private final RuleCall cValueINTASStringParserRuleCall_3_0_1 = (RuleCall)cValueAlternatives_3_0.eContents().get(1);
		
		//AttributesMapEntry:
		//	{AttributesMapEntry} key=Attribute (=> ':' | '=') value=(IDString | INTASString);
		@Override public ParserRule getRule() { return rule; }
		
		//{AttributesMapEntry} key=Attribute (=> ':' | '=') value=(IDString | INTASString)
		public Group getGroup() { return cGroup; }
		
		//{AttributesMapEntry}
		public Action getAttributesMapEntryAction_0() { return cAttributesMapEntryAction_0; }
		
		//key=Attribute
		public Assignment getKeyAssignment_1() { return cKeyAssignment_1; }
		
		//Attribute
		public RuleCall getKeyAttributeParserRuleCall_1_0() { return cKeyAttributeParserRuleCall_1_0; }
		
		//(=> ':' | '=')
		public Alternatives getAlternatives_2() { return cAlternatives_2; }
		
		//=> ':'
		public Keyword getColonKeyword_2_0() { return cColonKeyword_2_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_2_1() { return cEqualsSignKeyword_2_1; }
		
		//value=(IDString | INTASString)
		public Assignment getValueAssignment_3() { return cValueAssignment_3; }
		
		//(IDString | INTASString)
		public Alternatives getValueAlternatives_3_0() { return cValueAlternatives_3_0; }
		
		//IDString
		public RuleCall getValueIDStringParserRuleCall_3_0_0() { return cValueIDStringParserRuleCall_3_0_0; }
		
		//INTASString
		public RuleCall getValueINTASStringParserRuleCall_3_0_1() { return cValueINTASStringParserRuleCall_3_0_1; }
	}
	public class ImportElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.Import");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cImportAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cImportKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cImportURIAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cImportURISTRINGTerminalRuleCall_2_0 = (RuleCall)cImportURIAssignment_2.eContents().get(0);
		
		//Import machine::Import:
		//	{machine::Import}
		//	'import' importURI=STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//{machine::Import} 'import' importURI=STRING
		public Group getGroup() { return cGroup; }
		
		//{machine::Import}
		public Action getImportAction_0() { return cImportAction_0; }
		
		//'import'
		public Keyword getImportKeyword_1() { return cImportKeyword_1; }
		
		//importURI=STRING
		public Assignment getImportURIAssignment_2() { return cImportURIAssignment_2; }
		
		//STRING
		public RuleCall getImportURISTRINGTerminalRuleCall_2_0() { return cImportURISTRINGTerminalRuleCall_2_0; }
	}
	public class EBigDecimalElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.EBigDecimal");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final RuleCall cINTTerminalRuleCall_1 = (RuleCall)cGroup.eContents().get(1);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cFullStopKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final RuleCall cINTTerminalRuleCall_2_1 = (RuleCall)cGroup_2.eContents().get(1);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Alternatives cAlternatives_3_0 = (Alternatives)cGroup_3.eContents().get(0);
		private final Keyword cEKeyword_3_0_0 = (Keyword)cAlternatives_3_0.eContents().get(0);
		private final Keyword cEKeyword_3_0_1 = (Keyword)cAlternatives_3_0.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_3_1 = (Keyword)cGroup_3.eContents().get(1);
		private final RuleCall cINTTerminalRuleCall_3_2 = (RuleCall)cGroup_3.eContents().get(2);
		
		//EBigDecimal ecore::EBigDecimal:
		//	'-'? INT ('.' INT)? (('E' | 'e') '-'? INT)?;
		@Override public ParserRule getRule() { return rule; }
		
		//'-'? INT ('.' INT)? (('E' | 'e') '-'? INT)?
		public Group getGroup() { return cGroup; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_0() { return cHyphenMinusKeyword_0; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_1() { return cINTTerminalRuleCall_1; }
		
		//('.' INT)?
		public Group getGroup_2() { return cGroup_2; }
		
		//'.'
		public Keyword getFullStopKeyword_2_0() { return cFullStopKeyword_2_0; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_2_1() { return cINTTerminalRuleCall_2_1; }
		
		//(('E' | 'e') '-'? INT)?
		public Group getGroup_3() { return cGroup_3; }
		
		//('E' | 'e')
		public Alternatives getAlternatives_3_0() { return cAlternatives_3_0; }
		
		//'E'
		public Keyword getEKeyword_3_0_0() { return cEKeyword_3_0_0; }
		
		//'e'
		public Keyword getEKeyword_3_0_1() { return cEKeyword_3_0_1; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_3_1() { return cHyphenMinusKeyword_3_1; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_3_2() { return cINTTerminalRuleCall_3_2; }
	}
	public class IDStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.IDString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cIDTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cSTRINGTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//IDString:
		//	ID | STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//ID | STRING
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_0() { return cIDTerminalRuleCall_0; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_1() { return cSTRINGTerminalRuleCall_1; }
	}
	public class INTASStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.INTASString");
		private final RuleCall cINTTerminalRuleCall = (RuleCall)rule.eContents().get(1);
		
		//INTASString:
		//	INT;
		@Override public ParserRule getRule() { return rule; }
		
		//INT
		public RuleCall getINTTerminalRuleCall() { return cINTTerminalRuleCall; }
	}
	public class IIDElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.IID");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cINTTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//IID:
		//	INT | ID;
		@Override public ParserRule getRule() { return rule; }
		
		//INT | ID
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_0() { return cINTTerminalRuleCall_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1() { return cIDTerminalRuleCall_1; }
	}
	public class ResourceQualifiedNameElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.ResourceQualifiedName");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cIIDParserRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cFullStopKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final RuleCall cIIDParserRuleCall_1_1 = (RuleCall)cGroup_1.eContents().get(1);
		
		//ResourceQualifiedName:
		//	IID ('.' IID)?;
		@Override public ParserRule getRule() { return rule; }
		
		//IID ('.' IID)?
		public Group getGroup() { return cGroup; }
		
		//IID
		public RuleCall getIIDParserRuleCall_0() { return cIIDParserRuleCall_0; }
		
		//('.' IID)?
		public Group getGroup_1() { return cGroup_1; }
		
		//'.'
		public Keyword getFullStopKeyword_1_0() { return cFullStopKeyword_1_0; }
		
		//IID
		public RuleCall getIIDParserRuleCall_1_1() { return cIIDParserRuleCall_1_1; }
	}
	public class ResourceItemQualifiedNameElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.lsat.dispatching.teditor.Dispatching.ResourceItemQualifiedName");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cIIDParserRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cFullStopKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final RuleCall cIIDParserRuleCall_1_1 = (RuleCall)cGroup_1.eContents().get(1);
		
		//ResourceItemQualifiedName:
		//	IID ('.' IID)?;
		@Override public ParserRule getRule() { return rule; }
		
		//IID ('.' IID)?
		public Group getGroup() { return cGroup; }
		
		//IID
		public RuleCall getIIDParserRuleCall_0() { return cIIDParserRuleCall_0; }
		
		//('.' IID)?
		public Group getGroup_1() { return cGroup_1; }
		
		//'.'
		public Keyword getFullStopKeyword_1_0() { return cFullStopKeyword_1_0; }
		
		//IID
		public RuleCall getIIDParserRuleCall_1_1() { return cIIDParserRuleCall_1_1; }
	}
	
	
	private final ActivityDispatchingElements pActivityDispatching;
	private final ResourceIterationsMapEntryElements pResourceIterationsMapEntry;
	private final DispatchGroupElements pDispatchGroup;
	private final NumberRepeatsElements pNumberRepeats;
	private final RangeElements pRange;
	private final ResourceYieldMapEntryElements pResourceYieldMapEntry;
	private final AttributeElements pAttribute;
	private final DispatchElements pDispatch;
	private final AttributesMapEntryElements pAttributesMapEntry;
	private final ImportElements pImport;
	private final EBigDecimalElements pEBigDecimal;
	private final IDStringElements pIDString;
	private final INTASStringElements pINTASString;
	private final IIDElements pIID;
	private final ResourceQualifiedNameElements pResourceQualifiedName;
	private final ResourceItemQualifiedNameElements pResourceItemQualifiedName;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public DispatchingGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pActivityDispatching = new ActivityDispatchingElements();
		this.pResourceIterationsMapEntry = new ResourceIterationsMapEntryElements();
		this.pDispatchGroup = new DispatchGroupElements();
		this.pNumberRepeats = new NumberRepeatsElements();
		this.pRange = new RangeElements();
		this.pResourceYieldMapEntry = new ResourceYieldMapEntryElements();
		this.pAttribute = new AttributeElements();
		this.pDispatch = new DispatchElements();
		this.pAttributesMapEntry = new AttributesMapEntryElements();
		this.pImport = new ImportElements();
		this.pEBigDecimal = new EBigDecimalElements();
		this.pIDString = new IDStringElements();
		this.pINTASString = new INTASStringElements();
		this.pIID = new IIDElements();
		this.pResourceQualifiedName = new ResourceQualifiedNameElements();
		this.pResourceItemQualifiedName = new ResourceItemQualifiedNameElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.eclipse.lsat.dispatching.teditor.Dispatching".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//ActivityDispatching:
	//	{ActivityDispatching} imports+=Import* ('throughput'
	//	'{' ('iterations' ':' numberOfIterations=INT)?
	//	resourceIterations+=ResourceIterationsMapEntry*
	//	'}')?
	//	dispatchGroups+=DispatchGroup*;
	public ActivityDispatchingElements getActivityDispatchingAccess() {
		return pActivityDispatching;
	}
	
	public ParserRule getActivityDispatchingRule() {
		return getActivityDispatchingAccess().getRule();
	}
	
	//ResourceIterationsMapEntry:
	//	'iterations' '.' key=[machine::IResource|ResourceQualifiedName] ':' value=INT;
	public ResourceIterationsMapEntryElements getResourceIterationsMapEntryAccess() {
		return pResourceIterationsMapEntry;
	}
	
	public ParserRule getResourceIterationsMapEntryRule() {
		return getResourceIterationsMapEntryAccess().getRule();
	}
	
	//DispatchGroup:
	//	{DispatchGroup}
	//	'activities'
	//	name=IDString? ('(' (userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')? ('repeat'
	//	iteratorName=IDString? ':' (=> repeats+=NumberRepeats | '[' repeats+=Range (',' repeats+=Range)* ']'))?
	//	'{' ('yield' ':' yield=INT)?
	//	resourceYield+=ResourceYieldMapEntry* ('offset' ':' offset=EBigDecimal)?
	//	dispatches+=Dispatch*
	//	'}';
	public DispatchGroupElements getDispatchGroupAccess() {
		return pDispatchGroup;
	}
	
	public ParserRule getDispatchGroupRule() {
		return getDispatchGroupAccess().getRule();
	}
	
	//NumberRepeats Repeat:
	//	{Repeat} numRepeats=INT;
	public NumberRepeatsElements getNumberRepeatsAccess() {
		return pNumberRepeats;
	}
	
	public ParserRule getNumberRepeatsRule() {
		return getNumberRepeatsAccess().getRule();
	}
	
	//Range Repeat:
	//	{Repeat} (start=INT | start=INT ".." end=INT);
	public RangeElements getRangeAccess() {
		return pRange;
	}
	
	public ParserRule getRangeRule() {
		return getRangeAccess().getRule();
	}
	
	//ResourceYieldMapEntry:
	//	'yield' key=[machine::IResource|ResourceQualifiedName] ':' value=INT;
	public ResourceYieldMapEntryElements getResourceYieldMapEntryAccess() {
		return pResourceYieldMapEntry;
	}
	
	public ParserRule getResourceYieldMapEntryRule() {
		return getResourceYieldMapEntryAccess().getRule();
	}
	
	//Attribute:
	//	{Attribute} name=ID;
	public AttributeElements getAttributeAccess() {
		return pAttribute;
	}
	
	public ParserRule getAttributeRule() {
		return getAttributeAccess().getRule();
	}
	
	//Dispatch:
	//	activity=[activity::Activity] ('[' resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName] (','
	//	resourceItems+=[machine::ResourceItem|ResourceItemQualifiedName])* ']')? ('(' description=STRING?
	//	(userAttributes+=AttributesMapEntry (',' userAttributes+=AttributesMapEntry)*)? ')')?;
	public DispatchElements getDispatchAccess() {
		return pDispatch;
	}
	
	public ParserRule getDispatchRule() {
		return getDispatchAccess().getRule();
	}
	
	//AttributesMapEntry:
	//	{AttributesMapEntry} key=Attribute (=> ':' | '=') value=(IDString | INTASString);
	public AttributesMapEntryElements getAttributesMapEntryAccess() {
		return pAttributesMapEntry;
	}
	
	public ParserRule getAttributesMapEntryRule() {
		return getAttributesMapEntryAccess().getRule();
	}
	
	//Import machine::Import:
	//	{machine::Import}
	//	'import' importURI=STRING;
	public ImportElements getImportAccess() {
		return pImport;
	}
	
	public ParserRule getImportRule() {
		return getImportAccess().getRule();
	}
	
	//EBigDecimal ecore::EBigDecimal:
	//	'-'? INT ('.' INT)? (('E' | 'e') '-'? INT)?;
	public EBigDecimalElements getEBigDecimalAccess() {
		return pEBigDecimal;
	}
	
	public ParserRule getEBigDecimalRule() {
		return getEBigDecimalAccess().getRule();
	}
	
	//IDString:
	//	ID | STRING;
	public IDStringElements getIDStringAccess() {
		return pIDString;
	}
	
	public ParserRule getIDStringRule() {
		return getIDStringAccess().getRule();
	}
	
	//INTASString:
	//	INT;
	public INTASStringElements getINTASStringAccess() {
		return pINTASString;
	}
	
	public ParserRule getINTASStringRule() {
		return getINTASStringAccess().getRule();
	}
	
	//IID:
	//	INT | ID;
	public IIDElements getIIDAccess() {
		return pIID;
	}
	
	public ParserRule getIIDRule() {
		return getIIDAccess().getRule();
	}
	
	//ResourceQualifiedName:
	//	IID ('.' IID)?;
	public ResourceQualifiedNameElements getResourceQualifiedNameAccess() {
		return pResourceQualifiedName;
	}
	
	public ParserRule getResourceQualifiedNameRule() {
		return getResourceQualifiedNameAccess().getRule();
	}
	
	//ResourceItemQualifiedName:
	//	IID ('.' IID)?;
	public ResourceItemQualifiedNameElements getResourceItemQualifiedNameAccess() {
		return pResourceItemQualifiedName;
	}
	
	public ParserRule getResourceItemQualifiedNameRule() {
		return getResourceItemQualifiedNameAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
